#include <u.h>
#include <libc.h>
#include <bin.h>
#include <httpd.h>
#include <misc.h>

int
hredirected(HConnect *c, char *how, char *uri, char *options)
{
	Hio *hout;
	char *s, *ss, *host;
	int n;

	if(options == nil)
		options = "";

	/*
	*	For example
	*	the req.uri is
	*	http://host/path
	*	and the uri is
	*	/path or path
	*/

	host = c->head.host;
	if(strchr(uri, ':'))
		host = "";
	else if(uri[0] != '/'){
		s = strrchr(c->req.uri, '/');
		if(s != nil)
			*s = '\0';
		ss = halloc(c, strlen(c->req.uri) + strlen(uri) + 2 + UTFmax);
		sprint(ss, "%s/%s", c->req.uri, uri);
		uri = ss;
		if(s != nil)
			*s = '/';
	}

	n = snprint(c->xferbuf, HBufSize, 
			"<html><head><title>Redirection</title></head>\r\n"
			"<body><h1>Redirection</h1>\r\n"
			"Your selection can be found <a href=\"%U\"> here</a>.<p></body></html>\r\n", uri);

	hout = &c->hout;
	hprint(hout, "%s %s\r\n", hversion, how);
	hprint(hout, "Date: %D\r\n", time(nil));
	hprint(hout, "Server: Plan9\r\n");
	hprint(hout, "Content-type: text/html\r\n");
	hprint(hout, "Content-Length: %d\r\n", n);
	if(host == nil || host[0] == 0)
		hprint(hout, "Location: %U%s\r\n", uri,options);
	else
		hprint(hout, "Location: %U%U%s\r\n", uriconnection, uri,options);
	if(c->head.closeit)
		hprint(hout, "Connection: close\r\n");
	else if(!http11(c))
		hprint(hout, "Connection: Keep-Alive\r\n");
	hprint(hout, "\r\n");

	if(strcmp(c->req.meth, "HEAD") != 0)
		hwrite(hout, c->xferbuf, n);

	if(c->replog){
		if(host == nil || host[0] == 0)
			c->replog(c, "Reply: %s\nRedirect: %U%s\n", how, uri, options);
		else
			c->replog(c, "Reply: %s\nRedirect: %U%U%s\n", how, uriconnection, uri, options);
	}
	return hflush(hout);
}

/*
*	It's better to close connection if destination is not
*	this name space.
*	uri:
*	"/~who/path"
*	"/path"
*/
int
hmoved(HConnect *c, char *uri, char *options)
{
	char *p, *u;
	u = nil; // user in uri
	if(uri[0] == '/'){
		if(uri[1] == '~'){
			p = strchr(uri+2, '/');
			if(p)
				*p = 0;
			u = hstrdup(c, uri+2);
			if(p)
				*p = '/';
		}
		if(xstrcmp(c->req.user, u) != 0)
			c->head.closeit = 1;
	}
	else
		c->head.closeit = 1;
	
	return hredirected(c, "301 Moved Permanently", uri, options);
}
