#include <u.h>
#include <libc.h>
#include <ctype.h>
#include <bin.h>
#include <httpd.h>

/*	original code is
int
hurlfmt(Fmt *f)
{
	char buf[HMaxWord*2];
	Rune r;
	char *s;
	int t;

	s = va_arg(f->args, char*);
	for(t = 0; t < sizeof(buf) - 8; ){
		s += chartorune(&r, s);
		if(r == 0)
			break;
		if(r <= ' ' || r == '%' || r >= Runeself)
			t += snprint(&buf[t], sizeof(buf)-t, "%%%2.2x", r);
		else
			buf[t++] = r;
	}
	buf[t] = 0;
	return fmtstrcpy(f, buf);
}
*/


/*	Kenar's alternative */
int
hurlfmt(Fmt *f)
{
	char *b, c;
	char *s, *t, *e;
	int n, status;
	//char *unsafe=" %;?#<>\"{}|\\^`";
	char *unsafe=" %<>\"{}|\\^`";
	char *delm=";?#";

	s = va_arg(f->args, char*);

	/*	unsafe chars in path that should be escaped. see RFC2396,3987
	*	We have redirection case
	*	For example, suppose that
	*		path1 is redirected to path2?query
	*	then s is path2?query and only path2 should be encoded
	*	Don't touch after delm char.
	*/

	n = 0;
	t = s;
	while(*t && !strchr(delm,*t)){
		if(iscntrl(*t)||strchr(unsafe,*t))
			n += 3;
		else
			n++;
		t++;
	}
	n += strlen(t) + 1;
	c = *t;
	*t = 0;

	b = malloc(n);
	t = b;
	e = t + n;
	while(*s){
		if(iscntrl(*s)||strchr(unsafe,*s))
			t = seprint(t,e,"%%%02X", *s);
			/* upper case is recommended by RFC3987 */
		else
			*t++ = *s;
		s++;
	}
	*s = c;
	strcpy(t,s);

	
	status = fmtstrcpy(f, b);
	free(b);
	return status;
}


#ifdef nodef
/*	debug follows 	*/

void
usage(void)
{
	fprint(2,"usage: 8.out ....\n");
	exits("usage");
}

void
main(int argc, char *argv[])
{
	ARGBEGIN{
	default: usage();
	}ARGEND

	fmtinstall('U', hurlfmt);
	
	while(*argv)
		print("%U\n", *argv++);
}

/*	the result
term% 8c urlfmt.c
term% 8l urlfmt.8
term% 8.out alice '%' シナリオ '音楽' 'ab%c?de%f'
alice
%25
シナリオ
音楽
ab%25c?de%f
term% 
*/
#endif
